pipeline {
    agent any
    stages {
        stage('Build Docker Image'){
            steps {
                script {
                    app = docker.build("ncbao/webapp")
                    app.inside {
                        sh 'echo $(curl localhost:8080)'
                    }
                }
            }
        }
        stage('Push Docker Image'){
            steps {
                script {
                    docker.withRegistry('https://registry.hub.docker.com','docker_hub_ncbao') {
                        app.push("${env.BUILD_NUMBER}")
                        app.push("latest")
                    }               
                }
            }
        }
        stage('Deploy Docker To Development') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'webserver_login', usernameVariable: 'USERNAME', passwordVariable: 'USERPASS')]) {
                    script {
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$dev_ip \"docker pull ncbao/webapp:${env.BUILD_NUMBER}\""
                        try {
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$dev_ip \"docker stop webapp\""
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$dev_ip \"docker rm webapp\""
                        } catch (err) {
                            echo: 'caught error: $err'
                        }
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$dev_ip \"docker run --restart always --name webapp -p 8080:8080 -d ncbao/webapp:${env.BUILD_NUMBER}\""
                    }
                }
            }
        }
        stage('Deploy Docker To Stagging') {
            steps {
                withCredentials([usernamePassword(credentialsId: 'webserver_login', usernameVariable: 'USERNAME', passwordVariable: 'USERPASS')]) {
                    script {
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$stagging_ip \"docker pull ncbao/webapp:${env.BUILD_NUMBER}\""
                        try {
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$stagging_ip \"docker stop webapp\""
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$stagging_ip \"docker rm webapp\""
                        } catch (err) {
                            echo: 'caught error: $err'
                        }
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$stagging_ip \"docker run --restart always --name webapp -p 8080:8080 -d ncbao/webapp:${env.BUILD_NUMBER}\""
                    }
                }
            }
        }
        stage('Deploy Docker To Production') {
            steps {
                input 'Deploy to Production?'
                milestone(1)
                withCredentials([usernamePassword(credentialsId: 'webserver_login', usernameVariable: 'USERNAME', passwordVariable: 'USERPASS')]) {
                    script {
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$prod_ip \"docker pull ncbao/webapp:${env.BUILD_NUMBER}\""
                        try {
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$prod_ip \"docker stop webapp\""
                            sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$prod_ip \"docker rm webapp\""
                        } catch (err) {
                            echo: 'caught error: $err'
                        }
                        sh "sshpass -p '$USERPASS'  ssh -o StrictHostKeyChecking=no $USERNAME@$prod_ip \"docker run --restart always --name webapp -p 8080:8080 -d ncbao/webapp:${env.BUILD_NUMBER}\""
                    }
                }
            }
        }
    }
}
